Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c (revision 397937)
+++ channels/chan_sip.c (working copy)
@@ -16919,7 +16919,14 @@
                                                break;
                                        case PARSE_REGISTER_UPDATE:
                                                ast_string_field_set(p, fullcontact, peer->fullcontact);
-                                               update_peer(peer, p->expiry);
+                                               /* A peer that has been unregistered will have expire = -1 and the sock address
+                                                * will be null.  Otherwise, a realtime peer where rtchachefriends is turned
+                                                * off will return expire = -1 but have a sock address.  When we unregister a
+                                                * peer, we do not want to add back what was just removed from the db.
+                                                */
+                                               if ((peer->expire > -1) || (!ast_sockaddr_isnull(&peer->addr))) {
+                                                       update_peer(peer, p->expiry);
+                                               }
                                                /* Say OK and ask subsystem to retransmit msg counter */
                                                transmit_response_with_date(p, "200 OK", req);
                                                send_mwi = 1;

